template swap(T) {
    void swap(inout T t1, inout T t2) {
        T t = t1;
        t1 = t2;
        t2 = t;
    }
}

template max(T) {
    T max(T t1, T t2) {
        if (t1 < t2) return t2;
        return t1;
    }
}

template min(T) {
    T min(T t1, T t2) {
        if (t1 > t2) return t2;
        return t1;
    }
}

class Greater(T) {
    static bool opCall(T t1, T t2) { return t1 > t2; }
}

class Lesser(T) {
    static bool opCall(T t1, T t2) { return t1 < t2; }
}

template pop(T) {
    T pop(inout T[] a) {
        T t = a[$-1];
        a.length = a.length - 1;
        return t;
    }
}
